/**
 *
 */
package de.intevation.gnv.action;

import de.intevation.gnv.action.sessionmodel.SessionModel;
import de.intevation.gnv.action.sessionmodel.SessionModelFactory;

import de.intevation.gnv.artifactdatabase.client.ArtifactDatabaseClientFactory;
import de.intevation.gnv.artifactdatabase.client.exception.ArtifactDatabaseClientException;
import de.intevation.gnv.artifactdatabase.client.exception.ArtifactDatabaseInputException;

import de.intevation.gnv.artifactdatabase.objects.ArtifactObject;

import java.util.Collection;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/**
 * @author Tim Englich <tim.englich@intevation.de>
 * @author Ingo Weinzierl (ingo.weinzierl@intevation.de)
 * 
 */
public class FetchArtifactFactoriesAction extends ArtifactDatabaseActionBase {
    /**
     * the logger, used to log exceptions and additonaly information
     */
    private static Logger log = Logger
            .getLogger(FetchArtifactFactoriesAction.class);

    public FetchArtifactFactoriesAction() {
        super();
    }

    /**
     * @see de.intevation.gnv.action.ArtifactDatabaseActionBase#execute(org.apache.struts.action.ActionMapping,
     *      org.apache.struts.action.ActionForm,
     *      javax.servlet.http.HttpServletRequest,
     *      javax.servlet.http.HttpServletResponse)
     */
    @Override
    public ActionForward execute(ActionMapping mapping, ActionForm form,
                                 HttpServletRequest request,
                                 HttpServletResponse response) throws Exception {
        log.debug("ArtifactDatabaseActionBase.execute");
        try {
            Collection<ArtifactObject> artifactFactories =
                ArtifactDatabaseClientFactory.getInstance()
                    .getArtifactDatabaseClient(getLocale(request))
                    .getArtifactFactories();

            SessionModel sm = SessionModelFactory.getInstance().getSessionModel(
                request);

            sm.setArtifacteFactories(artifactFactories);

            return super.execute(mapping, form, request, response);
        }
        catch (ArtifactDatabaseClientException e) {
            log.error(e, e);
            request.setAttribute(
                CommunicationKeys.REQUEST_EXCEPTION_INPUT_ID,
                e.getMessage());

            return super.getExceptionForward(mapping);
        }
        catch (Exception e) {
            log.error(e, e);
            request.setAttribute(
                CommunicationKeys.REQUEST_EXCEPTION_MESSAGE_ID,
                e.getMessage());

            return super.getExceptionForward(mapping);
        }
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf-8 :
